/*start=============================================================================================================================
 * 
 *Arduino AiO - Zusatzprogramm Sniffer
 *
 *Autoren: 
 * 
 *Hobbybrauer.de : Bitter und Borsti84 
 * 
 * 
 * xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 * Die Software wird unter der MIT - Lizenz veröffentlicht
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files , 
 * to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Hiermit wird unentgeltlich jeder Person, die eine Kopie der Software und der zugehörigen Dokumentationen erhält, die Erlaubnis erteilt, 
 * sie uneingeschränkt zu benutzen, inklusive und ohne Ausnahme dem Recht, sie zu verwenden, kopieren, ändern, fusionieren, verlegen, verbreiten, unterlizenzieren 
 * und/oder zu verkaufen, und Personen, die diese Software erhalten, diese Rechte zu geben, unter den folgenden Bedingungen:
 * Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in allen Kopien oder Teilkopien der Software beizulegen.
 * DIE SOFTWARE WIRD OHNE JEDE AUSDRÜCKLICHE ODER IMPLIZIERTE GARANTIE BEREITGESTELLT, EINSCHLIESSLICH DER GARANTIE ZUR BENUTZUNG FÜR DEN VORGESEHENEN ODER 
 * EINEM BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTSVERLETZUNG, JEDOCH NICHT DARAUF BESCHRÄNKT. IN KEINEM FALL SIND DIE AUTOREN ODER COPYRIGHTINHABER FÜR JEGLICHEN  
 * SCHADEN ODER SONSTIGE ANSPRÜCHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFÜLLUNG EINES VERTRAGES, EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER 
 * SOFTWARE ODER SONSTIGER VERWENDUNG DER SOFTWARE ENTSTANDEN.
 * xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 * 
 * Das Programm funktioniert nur mit verbautem 433 MHz-Empfänger.
 * 
 * Vorgehensweise:
 * 
 * Zunächst die Steckdosen mit der Fernsteuerung anlernen. Dann die Steckdosen kennzeichnen, z.B. für die Heizung mit "H" usw.
 * Dann diese Software auf den Arduino überspielen. Erscheint im Display "Heizung EIN", die Taste für Heizung EIN drücken, also die Taste
 * mit der vorher die Steckdose "H" angelernt wurde. Dies für alle gewünschten Steckdosen wiederholen. 
 * Nachher befindet sich der Steckdosencode im EEPROM und steht auch nach Aufspielen der Brausoftware zur Verfügung.
 */

unsigned long funk_heizung_ein;
unsigned long funk_heizung_aus;

unsigned long funk_ruehrer_ein;
unsigned long funk_ruehrer_aus;

//Brauerruf auf die Funksteckdose!
unsigned long funk_ruf_ein;
unsigned long funk_ruf_aus;

#include <Wire.h>
#include <LiquidCrystal_I2C.h>
// set the LCD address to 0x27 for a 20 chars 4 line display
// Set the pins on the I2C chip used for LCD connections:
//                    addr, en,rw,rs,d4,d5,d6,d7,bl,blpol
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address

//Funksender----------------------------------------------------------
#include <RCSwitch.h>
RCSwitch mySwitch = RCSwitch();

#define RESEND_SNIFFED_VALUES 10
unsigned long value;

//------------------------------------------------------------------


//EEPROM ----------------------------------------------------------
#include <EEPROM.h>   //EEPROM 

/*
 * Speicheraufteilung
 *
 * Hysterese [0]
 * 433 MHz - Heizung EIN [1]
 * 433 MHz - Heizung AUS [4]
 * 433 MHz - Rührer EIN [7]
 * 433 MHz - Rührer AUS [10]
 * 433 MHz - Ruf EIN [13]
 * 433 MHz - Ruf AUS [16]
 */

//------------------------------------------------------------------

byte anfang = 0;
byte drehen = 1;
byte adr;
byte modus;


void setup() {
    //LCD Setup ------------------------------------------------------
  lcd.begin(20, 4);  // initialize the lcd for 20 chars 4 lines, turn on backlight
  lcd.backlight(); // backlight on
  // 434 receiver on interrupt #1
  mySwitch.enableReceive(0);
  modus = 0;
}

void loop() {
  //Binärcode für Funksteckdosen ermitteln ----------------------------------------------
  if (modus == 0) steckdosencode();
  if (modus == 1) {lcd.clear(); lcd.setCursor(0,0); lcd.print("Fertig Anlernen"); while (1) {;}}
}  

void steckdosencode() 
{
  if (anfang == 0)
  {
    lcd.clear();
    lcd.setCursor(0, 0); lcd.print("Anlernen Funkdosen");
    drehen = 1;
    anfang = 1;
  }
  else
  {
    lcd.setCursor(0, 0); lcd.print("Anlernen Funkdosen");
    if (drehen == 1) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Heizung EIN");
      adr = 1;
    }
    if (drehen == 2) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Heizung AUS");
      adr = 4;
    }
    if (drehen == 3) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Ruehrer EIN");
      adr = 7;
    }
    if (drehen == 4) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Ruehrer AUS");
      adr = 10;
    }
    if (drehen == 5) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Ruf EIN");
      adr = 13;
    }
    if (drehen == 6) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Ruf AUS");
      adr = 16;
    }

    if (drehen > 6) drehen = 1;


    value = mySwitch.getReceivedValue();
    if (value) {
      lcd.setCursor(0, 2); lcd.print(value);
      // value in EPROM schreiben
      if (EEPROMReadlong(adr) != value) EEPROMWritelong(adr, value);
      lcd.setCursor(0, 2);
      lcd.print("speichern");
      delay(500);
      drehen++;
      if (drehen == 7) {
        modus = 1;
        anfang = 0;
      }
      lcd.clear();
    }
    mySwitch.resetAvailable();
    
  }
}

void EEPROMWritelong(int address, long value)
{
  byte four = (value & 0xFF);
  byte three = ((value >> 8) & 0xFF);
  byte two = ((value >> 16) & 0xFF);

  EEPROM.write(address, four);
  EEPROM.write(address + 1, three);
  EEPROM.write(address + 2, two);
}


long EEPROMReadlong(long address)
{
  long four = EEPROM.read(address);
  long three = EEPROM.read(address + 1);
  long two = EEPROM.read(address + 2);

  return ((four << 0) & 0xFF) + ((three << 8) & 0xFFFF) + ((two << 16) & 0xFFFFFF);
}



